<?php

function seoposition_regions() {
	return array(
			'above_content' => t('above content'),
			'content' => t('content'),
			'sidebar_top' => t('sidebar top'),
			'sidebar_left' => t('left sidebar'),
			'sidebar_right' => t('right sidebar'),
			'footer' => t('footer'),
	);
}

// adds branch indicators to menu links
function phptemplate_menu_item($mid, $children = '', $leaf = TRUE) {
	// grab text from link
	$link = menu_item_link($mid);
	$textbegin = strpos($link, ">") + 1;
	$textend = strpos($link, "<", 2);
	$textlen = $textend - $textbegin;
	$text = substr($link, $textbegin, $textlen);
	$text = $text.($leaf ? '' : ($children ? ':' : '&hellip;'));
	$link = substr_replace($link, $text, $textbegin, $textlen);
	
	return'<li class="'. ($leaf ? 'leaf' : ($children ? 'expanded' : 'collapsed')) .'">'. $link . $children ."</li>\n";
}

// modified to allow reordering and theming of 'add comment' & 'read more' links
function phptemplate_links($links, $attributes = array('class' => 'links')) {
  $output = '';

  if (count($links) > 0) {
    $output = '<ul'. drupal_attributes($attributes) .'>';

    $num_links = count($links);
    $i = 1;

    foreach ($links as $key => $link) {
      $class = '';

      // Automatically add a class to each link and also to each LI
      if (isset($link['attributes']) && isset($link['attributes']['class'])) {
        $link['attributes']['class'] .= ' ' . $key;
        $class = $key;
      }
      else {
        $link['attributes']['class'] = $key;
        $class = $key;
      }

      // Add first and last classes to the list of links to help out themers.
      $extra_class = '';
      if ($i == 1) {
        $extra_class .= 'first ';
      }
      if ($i == $num_links) {
        $extra_class .= 'last ';
      }
      $outputbuffer = '<li class="'. $extra_class . $class .'">';

      // Is the title HTML?
      $html = isset($link['html']) && $link['html'];

      // Initialize fragment and query variables.
      $link['query'] = isset($link['query']) ? $link['query'] : NULL;
      $link['fragment'] = isset($link['fragment']) ? $link['fragment'] : NULL;

      if (isset($link['href'])) {
        // catch comment links
				if ($key == "comment_comments" or $key == "comment_add") {
					$outputbuffer .= "(".l($link['title'], $link['href'], $link['attributes'], $link['query'], $link['fragment'], FALSE, $html).")";
				} elseif ($key=="node_read_more") {
					$outputbuffer .= l("Read the full story...", $link['href'], $link['attributes'], $link['query'], $link['fragment'], FALSE, $html);
				} else {
					$outputbuffer .= l($link['title'], $link['href'], $link['attributes'], $link['query'], $link['fragment'], FALSE, $html);
				}
      }
      else if ($link['title']) {
        //Some links are actually not links, but we wrap these in <span> for adding title and class attributes
        if (!$html) {
          $link['title'] = check_plain($link['title']);
        }
        $outputbuffer .= '<span'. drupal_attributes($link['attributes']) .'>'. $link['title'] .'</span>';
      }

      $i++;
      if ($key == "comment_comments" or $key == "comment_add") {
				// store comment links for later
				$outputtail = $outputbuffer."</li>\n";
			} else {
				$output .= $outputbuffer."</li>\n";
			}
    }
		// finally output the comment links
    $output .= $outputtail.'</ul>';
  }

  return $output;
} 

// fixes this bug: http://drupal.org/node/111719 (feel free to remove when drupal patches this bug)
function phptemplate_submit($element) {
  global $elementCountForHack;
  return str_replace('edit-submit', 'edit-submit-' . ++$elementCountForHack, theme('button', $element));
}
